/**
 * Created by Kevin on 28.05.2017.
 */

window.onresize = function () {
    windowWidth = window.innerWidth;
    windowHeight = window.innerHeight;
    rtime = new Date();
    if (!rtimeout) {
        rtimeout = true;
        //document.getElementById("backgroundEffect").style.opacity = 0;
        setTimeout(resizeend, 1500);
    }
};

function resizeend() {
    if (new Date() - rtime < 1500) {
        setTimeout(resizeend, 100);
    } else {
        rtimeout = false;
        setupScreen();
    }
}

function setupScreen() {
    delete window.renderer;
    renderer = PIXI.autoDetectRenderer(windowWidth, windowHeight, {transparent: true});
    document.getElementById("backgroundEffect").innerHTML = "";
    document.getElementById("backgroundEffect").appendChild(renderer.view);
    renderer.view.position = "fixed";
    stage = new PIXI.Container();

    new Bug();

    //document.getElementById("backgroundEffect").style.opacity = 1;
}

function Bug() {
    var bug = {
        bug: new PIXI.Graphics(),
        center: {x: 200, y: 200},
        head: {x: 200, y: 100},
        size: 15,
        feet: {
            rT: {
                name: "rT",
                bodyPoint: {x: undefined, y: undefined},
                knee: {x: undefined, y: undefined},
                standing: true,
                pos: {x: 0, y: 0},
                target: {x: 0, y: 0}
            },
            rB: {
                name: "rB",
                bodyPoint: {x: undefined, y: undefined},
                knee: {x: undefined, y: undefined},
                standing: true,
                pos: {x: 0, y: 0},
                target: {x: 0, y: 0}
            },
            lB: {
                name: "lB",
                bodyPoint: {x: undefined, y: undefined},
                knee: {x: undefined, y: undefined},
                standing: true,
                pos: {x: 0, y: 0},
                target: {x: 0, y: 0}
            },
            lT: {
                name: "lT",
                bodyPoint: {x: undefined, y: undefined},
                knee: {x: undefined, y: undefined},
                standing: true,
                pos: {x: 0, y: 0},
                target: {x: 0, y: 0}
            }
        },
        footprints: new PIXI.Graphics()
    };
    bug.bug.position.x = 0;
    bug.bug.position.y = 0;

    stage.addChild(bug.footprints);
    stage.addChild(bug.bug);
    loop();

    function loop() {
        bug.bug.clear();
        bug.bug.lineStyle(1, 0x808080, 0.8);
        drawBody();
        drawFeet();

        renderer.render(stage);
        setTimeout(loop, 30);
    }

    function drawFeet() {
        for (var foot in bug.feet) {
            //console.log(bug.feet[foot].bodyPoint);
            //console.log(bug.feet[foot].standing);
            //console.log(bug.feet[foot].pos);
            //console.log(bug.feet[foot].target);
            if (bug.feet[foot].standing) {
                var neighbours;
                switch (bug.feet[foot].name) {
                    case "rT":
                        neighbours = {a: bug.head, b: bug.feet.rB.bodyPoint};
                        break;
                    case "rB":
                        neighbours = {a: bug.feet.rT.bodyPoint, b: bug.feet.lB.bodyPoint};
                        break;
                    case "lB":
                        neighbours = {a: bug.feet.rB.bodyPoint, b: bug.feet.lT.bodyPoint};
                        break;
                    case "lT":
                        neighbours = {a: bug.feet.lB.bodyPoint, b: bug.head};
                        break;
                }
                if ((getAngle(bug.feet[foot].bodyPoint, neighbours.a, bug.feet[foot].knee) + getAngle(bug.feet[foot].bodyPoint, neighbours.b, bug.feet[foot].knee)) < 150) {
                    var newFootPosition_result1 = newFootPosition(bug.feet[foot].name, bug.feet[foot].bodyPoint);
                    bug.feet[foot].standing = newFootPosition_result1.standing;
                    bug.feet[foot].target = newFootPosition_result1.newPoint;
                }
            }
            if (!bug.feet[foot].standing) {
                var newFootPos = vectorSum(bug.feet[foot].pos, vectorProduct(0.5, vectorDifference(bug.feet[foot].target, bug.feet[foot].pos)));
                if (getVectorLenght(vectorDifference(newFootPos, bug.feet[foot].bodyPoint)) < 1.5 * bug.size) {
                    var v_body_foot = vectorDifference(newFootPos, bug.feet[foot].bodyPoint);
                    var vE_body_foot = getUnitVector(v_body_foot);
                    bug.feet[foot].pos = vectorSum(bug.feet[foot].bodyPoint, vectorProduct(1.5 * bug.size, vE_body_foot));
                } else {
                    bug.feet[foot].pos = newFootPos;
                }

                //console.log(getVectorLenght(vectorDifference(bug.feet[foot].pos, bug.feet[foot].target)));
                if (getVectorLenght(vectorDifference(bug.feet[foot].pos, bug.feet[foot].target)) < 1) {
                    bug.feet[foot].standing = true;
                    bug.feet[foot].pos = bug.feet[foot].target;
                    bug.footprints.lineStyle(1, 0x808080, 0.11 + 0.2 * Math.random());
                    bug.footprints.drawCircle(bug.feet[foot].pos.x, bug.feet[foot].pos.y, 0.5);
                }
            }

            var upperLegLength = bug.size * 2;
            var lowerLegLength = bug.size;
            var distance_BodyFoot = getVectorLenght(vectorDifference(bug.feet[foot].pos, bug.feet[foot].bodyPoint));
            if (distance_BodyFoot >= upperLegLength + lowerLegLength || distance_BodyFoot < upperLegLength - lowerLegLength) {
                var newFootPosition_result2 = newFootPosition(bug.feet[foot].name, bug.feet[foot].bodyPoint);
                bug.feet[foot].standing = newFootPosition_result2.standing;
                bug.feet[foot].target = newFootPosition_result2.newPoint;
            }
            var angle_directReal = (180 / Math.PI) * Math.acos((Math.pow(upperLegLength, 2) + Math.pow(distance_BodyFoot, 2) - Math.pow(lowerLegLength, 2)) / (2 * upperLegLength * distance_BodyFoot));
            var v_direct = vectorDifference(bug.feet[foot].pos, bug.feet[foot].bodyPoint);
            var v_body_knee;
            if (bug.feet[foot].name[0] == "r") {
                v_body_knee = turnVector(v_direct, 360 - angle_directReal);
            } else {
                v_body_knee = turnVector(v_direct, angle_directReal);
            }
            var vE_body_knee = {
                x: v_body_knee.x / (Math.sqrt(Math.pow(v_body_knee.x, 2) + Math.pow(v_body_knee.y, 2))),
                y: v_body_knee.y / (Math.sqrt(Math.pow(v_body_knee.x, 2) + Math.pow(v_body_knee.y, 2)))
            };
            bug.feet[foot].knee = {
                x: bug.feet[foot].bodyPoint.x + (upperLegLength * vE_body_knee.x),
                y: bug.feet[foot].bodyPoint.y + (upperLegLength * vE_body_knee.y)
            };

            //console.log(distance_BodyFoot);
            //console.log(angle_directReal);
            //console.log(v_direct);
            //console.log(v_body_knee);
            //console.log(knee);
            bug.bug.moveTo(bug.feet[foot].bodyPoint.x, bug.feet[foot].bodyPoint.y);
            bug.bug.lineTo(bug.feet[foot].knee.x, bug.feet[foot].knee.y);
            bug.bug.lineTo(bug.feet[foot].pos.x, bug.feet[foot].pos.y);
        }
    }

    function newFootPosition(footName, bodyPoint) {
        var v_alignedtobody;
        var v_toNewPoint;
        switch (footName) {
            case "rT":
                v_alignedtobody = vectorDifference(bug.head, bodyPoint);
                v_toNewPoint = vectorProduct(Math.random() + 1.5, turnVector(v_alignedtobody, 70 + Math.random() * 20));
                break;
            case "rB":
                v_alignedtobody = vectorDifference(bug.feet.rT.bodyPoint, bodyPoint);
                v_toNewPoint = vectorProduct(Math.random() + 0.5, turnVector(v_alignedtobody, 40 + Math.random() * 20));
                break;
            case "lB":
                v_alignedtobody = vectorDifference(bug.feet.lT.bodyPoint, bodyPoint);
                v_toNewPoint = vectorProduct(Math.random() + 0.5, turnVector(v_alignedtobody, 360 - (40 + Math.random() * 20)));
                break;
            case "lT":
                v_alignedtobody = vectorDifference(bug.head, bodyPoint);
                v_toNewPoint = vectorProduct(Math.random() + 1.5, turnVector(v_alignedtobody, 360 - (70 + Math.random() * 20)));
                break;
        }
        return {
            standing: false,
            newPoint: vectorSum(bodyPoint, v_toNewPoint)
        };
    }

    function drawBody() {
        var standingfactor = 1;
        if (bug.feet.rT.standing)
            standingfactor++;
        if (bug.feet.rB.standing)
            standingfactor++;
        if (bug.feet.lB.standing)
            standingfactor++;
        if (bug.feet.lT.standing)
            standingfactor++;
        var intermediateStep = vectorSum(bug.head, vectorProduct(0.0025 * standingfactor, vectorDifference(mouse, bug.head)));
        bug.head.x = intermediateStep.x;
        bug.head.y = intermediateStep.y;
        var v_intermediateStep_center = vectorDifference(bug.center, intermediateStep);
        var vE_intermediateStep_center = getUnitVector(v_intermediateStep_center);
        bug.center = vectorSum(intermediateStep, vectorProduct(bug.size, vE_intermediateStep_center));

        bug.bug.moveTo(bug.head.x, bug.head.y);


        var v_centerToNewPoint = turnVector({
            x: bug.head.x - bug.center.x,
            y: bug.head.y - bug.center.y
        }, 72);
        bug.feet.rT.bodyPoint = vectorSum(bug.center, v_centerToNewPoint);
        v_centerToNewPoint = turnVector({
            x: bug.feet.rT.bodyPoint.x - bug.center.x,
            y: bug.feet.rT.bodyPoint.y - bug.center.y
        }, 72);
        bug.feet.rB.bodyPoint = vectorSum(bug.center, v_centerToNewPoint);
        v_centerToNewPoint = turnVector({
            x: bug.feet.rB.bodyPoint.x - bug.center.x,
            y: bug.feet.rB.bodyPoint.y - bug.center.y
        }, 72);
        bug.feet.lB.bodyPoint = vectorSum(bug.center, v_centerToNewPoint);
        v_centerToNewPoint = turnVector({
            x: bug.feet.lB.bodyPoint.x - bug.center.x,
            y: bug.feet.lB.bodyPoint.y - bug.center.y
        }, 72);
        bug.feet.lT.bodyPoint = vectorSum(bug.center, v_centerToNewPoint);

        bug.bug.lineTo(bug.feet.rT.bodyPoint.x, bug.feet.rT.bodyPoint.y);
        bug.bug.lineTo(bug.feet.rB.bodyPoint.x, bug.feet.rB.bodyPoint.y);
        bug.bug.lineTo(bug.feet.lB.bodyPoint.x, bug.feet.lB.bodyPoint.y);
        bug.bug.lineTo(bug.feet.lT.bodyPoint.x, bug.feet.lT.bodyPoint.y);
        bug.bug.lineTo(bug.head.x, bug.head.y);
    }

    function turnVector(vector, angle) {
        return {
            x: vector.x * Math.cos(angle / 180 * Math.PI) - vector.y * Math.sin(angle / 180 * Math.PI),
            y: vector.x * Math.sin(angle / 180 * Math.PI) + vector.y * Math.cos(angle / 180 * Math.PI)
        };
    }

    function getAngle(intersection, p1, p2) {
        var v1 = {x: p1.x - intersection.x, y: p1.y - intersection.y};
        var v2 = {x: p2.x - intersection.x, y: p2.y - intersection.y};
        return Math.acos((v1.x * v2.x + v1.y * v2.y) / ((Math.sqrt(Math.pow(v1.x, 2) + Math.pow(v1.y, 2))) * (Math.sqrt(Math.pow(v2.x, 2) + Math.pow(v2.y, 2))))) * (180 / Math.PI);
    }

    function getUnitVector(vector) {
        return {
            x: vector.x / (Math.sqrt(Math.pow(vector.x, 2) + Math.pow(vector.y, 2))),
            y: vector.y / (Math.sqrt(Math.pow(vector.x, 2) + Math.pow(vector.y, 2)))
        };
    }

    function getVectorLenght(vector) {
        return Math.sqrt(Math.pow(vector.x, 2) + Math.pow(vector.y, 2));
    }

    function vectorSum(vector1, vector2) {
        return {x: vector1.x + vector2.x, y: vector1.y + vector2.y};
    }

    function vectorDifference(vector1, vector2) {
        return {x: vector1.x - vector2.x, y: vector1.y - vector2.y};
    }

    function vectorProduct(factor, vector) {
        return {x: factor * vector.x, y: factor * vector.y}
    }
}

window.onmousemove = function (e) {
    mouse.x = e.clientX;
    mouse.y = e.clientY;
};

window.addEventListener("touchstart", function (e) {
    mouse.x = e.changedTouches[0].clientX;
    mouse.y = e.changedTouches[0].clientY;
}, false);

window.addEventListener("touchmove", function (e) {
    mouse.x = e.changedTouches[0].clientX;
    mouse.y = e.changedTouches[0].clientY;
}, false);

var rtime;
var rtimeout = false;

var windowWidth = window.innerWidth;
var windowHeight = window.innerHeight;
var mouse = {x: 0, y: 0};
var renderer;
var stage;

setupScreen();